Index: /trunk/src/org/expeditee/agents/SearchTree.java
===================================================================
--- /trunk/src/org/expeditee/agents/SearchTree.java	(revision 375)
+++ /trunk/src/org/expeditee/agents/SearchTree.java	(revision 376)
@@ -1,24 +1,33 @@
 package org.expeditee.agents;
 
+import java.io.BufferedReader;
+import java.io.FileNotFoundException;
+import java.io.FileReader;
+import java.io.IOException;
 import java.util.Collection;
+import java.util.HashMap;
 import java.util.HashSet;
+import java.util.LinkedList;
+import java.util.Map;
 
+import org.expeditee.gui.AttributeValuePair;
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameGraphics;
 import org.expeditee.gui.FrameIO;
-import org.expeditee.items.Text;
+import org.expeditee.gui.UserSettings;
+import org.expeditee.io.Conversion;
 
 public class SearchTree extends SearchAgent {
+	private Map<String, Collection<String>> _searchResults = new HashMap<String, Collection<String>>();
+
 	public SearchTree(String searchText) {
 		super(searchText);
 	}
-	
+
 	@Override
 	protected Frame process(Frame frame) {
-		try {
-			searchTree(new HashSet<String>(), _startName);
-		} catch (Exception e) {
-			e.printStackTrace();
-		}
+		if (frame == null)
+			frame = FrameIO.LoadFrame(_startName);
+
+		searchTree(frame.getName(), _searchResults, new HashSet<String>());
 		_results.save();
 
@@ -30,38 +39,131 @@
 	}
 
-	public boolean searchTree(Collection<String> visitedFrames, String frameName)
-			throws Exception {
-		if (_stop) {
-			return false;
+	@Override
+	/**
+	 * @param frame
+	 * @return
+	 */
+	protected String getSearchDescription(Frame frame) {
+		return frame.getName();
+	}
+
+	/**
+	 * Returns a list of the frames searched and any matches on those frames.
+	 * 
+	 * @param frameName
+	 *            the name of the top not in the tree of frames to search
+	 * @param pattern
+	 *            the pattern to search for
+	 * @param results
+	 *            a list of frames on which matches were found and the text that
+	 *            matched the pattern
+	 * @param visited
+	 *            a list of the frames that were visited in the searchTree
+	 */
+	public void searchTree(String frameName,
+			Map<String, Collection<String>> results, Collection<String> visited) {
+		// Check if this node has already been visited
+		if (visited.contains(frameName))
+			return;
+
+		visited.add(frameName);
+
+		String fullPath = null;
+		for (String possiblePath : UserSettings.FrameDirs) {
+			fullPath = FrameIO.getFrameFullPathName(possiblePath, frameName);
+			if (fullPath != null)
+				break;
 		}
-		// Avoid infinate loops
-		if (visitedFrames.contains(frameName))
-			return false;
-		visitedFrames.add(frameName);
 
-		Frame frameToSearch = FrameIO.LoadFrame(frameName);
-		if (frameToSearch == null)
-			return false;
+		// If the frame was not located return null
+		if (fullPath == null)
+			return;
 
+		_frameCount++;
 		overwriteMessage("Searching " + frameName);
 
-		for (Text itemToSearch : frameToSearch.getTextItems()) {
-			// Search for the item and add it to the results page if
-			// it is found
-			if (searchItem(itemToSearch, _pattern,
-					_replacementString)) {
-				// Add a linked item to the results frame
-				_results.addText(frameName, null, frameName, null, false);
-			}
-			if (!itemToSearch.isAnnotation()) {
-				String link = itemToSearch.getAbsoluteLink();
-				if (link != null) {
-					searchTree(visitedFrames, link);
+		String frameset = Conversion.getFramesetName(frameName);
+
+		Collection<String> frameResults = new LinkedList<String>();
+		// Open the file and search the text items
+		try {
+			BufferedReader reader = new BufferedReader(new FileReader(fullPath));
+			String next;
+			StringBuffer sb = new StringBuffer();
+			String link = null;
+			boolean ignore = false;
+
+			while (reader.ready() && ((next = reader.readLine()) != null)) {
+
+				if (next.length() == 0) {
+					// Ignore annotations
+					if (ignore) {
+						ignore = false;
+						link = null;
+						continue;
+					}
+
+					// Ignore non text items
+					if (sb.length() == 0) {
+						link = null;
+						continue;
+					}
+
+					String toSearch = sb.substring(0, sb.length() - 1);
+					String resultSurrogate = getResultSurrogate(toSearch);
+					if (resultSurrogate != null) {
+						frameResults.add(resultSurrogate);
+					}
+
+					if (link != null) {
+						searchTree(link, results, visited);
+					}
+
+					// Reinit the item variables
+					link = null;
+					sb = new StringBuffer();
+
+				} else if (ignore) {
+					continue;
+				} else if (next.startsWith("T")) {
+					String text = next.substring(2).trim();
+					// Ignore the rest of annotation items...
+					if (text.length() > 0
+							&& text.charAt(0) == AttributeValuePair.ANNOTATION_CHAR) {
+						ignore = true;
+						continue;
+					}
+					sb.append(text).append('\n');
+				} else if (next.startsWith("F")) {
+					link = next.substring(2);
+					// Convert number only links
+					if (Character.isDigit(link.charAt(0)))
+						link = frameset + link;
 				}
 			}
+			// Only add the results if a match was found on the frame
+			if (frameResults.size() > 0) {
+				results.put(frameName, frameResults);
+			}
+		} catch (FileNotFoundException e) {
+			e.printStackTrace();
+		} catch (IOException e) {
+			e.printStackTrace();
 		}
-		FrameGraphics.requestRefresh(true);
-		FrameIO.SaveFrame(frameToSearch, false);
-		return true;
+		int size = frameResults.size();
+		if (size > 0) {
+			addResults(frameName, frameResults);
+
+			// String repeats = size > 1 ? ("(" + size + ")") : "";
+			// _results.addText(frameName + repeats, null, frameName, null,
+			// false);
+			// FrameGraphics.requestRefresh(true);
+		}
+	}
+
+	protected String getResultSurrogate(String toSearch) {
+		if (toSearch.toLowerCase().contains(_pattern))
+			return toSearch;
+		return null;
 	}
 }
Index: /trunk/src/org/expeditee/agents/SearchTreeAndReplace.java
===================================================================
--- /trunk/src/org/expeditee/agents/SearchTreeAndReplace.java	(revision 376)
+++ /trunk/src/org/expeditee/agents/SearchTreeAndReplace.java	(revision 376)
@@ -0,0 +1,67 @@
+package org.expeditee.agents;
+
+import java.util.Collection;
+import java.util.HashSet;
+
+import org.expeditee.gui.Frame;
+import org.expeditee.gui.FrameGraphics;
+import org.expeditee.gui.FrameIO;
+import org.expeditee.items.Text;
+
+public class SearchTreeAndReplace extends SearchAgent {
+	public SearchTreeAndReplace(String searchText) {
+		super(searchText);
+	}
+	
+	@Override
+	protected Frame process(Frame frame) {
+		try {
+			searchTree(new HashSet<String>(), _startName);
+		} catch (Exception e) {
+			e.printStackTrace();
+		}
+		_results.save();
+
+		String resultFrameName = _results.getName();
+		if (_clicked != null)
+			_clicked.setLink(resultFrameName);
+
+		return _results.getFirstFrame();
+	}
+
+	public boolean searchTree(Collection<String> visitedFrames, String frameName)
+			throws Exception {
+		if (_stop) {
+			return false;
+		}
+		// Avoid infinate loops
+		if (visitedFrames.contains(frameName))
+			return false;
+		visitedFrames.add(frameName);
+
+		Frame frameToSearch = FrameIO.LoadFrame(frameName);
+		if (frameToSearch == null)
+			return false;
+
+		overwriteMessage("Searching " + frameName);
+
+		for (Text itemToSearch : frameToSearch.getTextItems()) {
+			// Search for the item and add it to the results page if
+			// it is found
+			if (searchItem(itemToSearch, _pattern,
+					_replacementString)) {
+				// Add a linked item to the results frame
+				_results.addText(frameName, null, frameName, null, false);
+			}
+			if (!itemToSearch.isAnnotation()) {
+				String link = itemToSearch.getAbsoluteLink();
+				if (link != null) {
+					searchTree(visitedFrames, link);
+				}
+			}
+		}
+		FrameGraphics.requestRefresh(true);
+		FrameIO.SaveFrame(frameToSearch, false);
+		return true;
+	}
+}
Index: /trunk/src/org/expeditee/agents/SpellcheckTree.java
===================================================================
--- /trunk/src/org/expeditee/agents/SpellcheckTree.java	(revision 376)
+++ /trunk/src/org/expeditee/agents/SpellcheckTree.java	(revision 376)
@@ -0,0 +1,52 @@
+package org.expeditee.agents;
+
+import java.io.FileNotFoundException;
+import java.io.IOException;
+
+import org.expeditee.agents.wordprocessing.JSpellChecker;
+
+public class SpellcheckTree extends SearchTree {
+
+	private JSpellChecker _spellChecker = null;
+
+	public SpellcheckTree() {
+		super(null);
+
+		try {
+			_spellChecker = JSpellChecker.getInstance();
+		} catch (FileNotFoundException e) {
+			e.printStackTrace();
+		} catch (IOException e) {
+			e.printStackTrace();
+		}
+		// TODO better handle errors
+	}
+
+	@Override
+	protected String getResultSurrogate(String toSearch) {
+		if (_spellChecker == null)
+			return null;
+		_spellChecker.setText(toSearch);
+		_spellChecker.check();
+
+		String badSpelling = _spellChecker.getMisspelledWord();
+		String result = badSpelling;
+//		while (badSpelling != null) {
+//			_spellChecker.ignoreWord(true);
+//			_spellChecker.check();
+//			badSpelling = _spellChecker.getMisspelledWord();
+//			if (badSpelling != null)
+//				result += "," + badSpelling;
+//		}
+
+		if (badSpelling == null || badSpelling.length() <= 1)
+			return null;
+
+		return "[" + result + "] " + toSearch;
+	}
+	
+	@Override
+	protected String getResultsTitleSuffix() {
+		return "";
+	}
+}
Index: /trunk/src/org/expeditee/agents/wordprocessing/JSpellChecker.java
===================================================================
--- /trunk/src/org/expeditee/agents/wordprocessing/JSpellChecker.java	(revision 375)
+++ /trunk/src/org/expeditee/agents/wordprocessing/JSpellChecker.java	(revision 376)
@@ -1,4 +1,5 @@
 package org.expeditee.agents.wordprocessing;
 
+import java.awt.Color;
 import java.io.File;
 import java.io.FileNotFoundException;
@@ -8,5 +9,8 @@
 import java.util.List;
 
+import org.expeditee.gui.Frame;
 import org.expeditee.gui.FrameIO;
+import org.expeditee.gui.MessageBay;
+import org.expeditee.items.Text;
 
 import com.swabunga.spell.engine.Configuration;
@@ -59,5 +63,6 @@
 	public static JSpellChecker _theInstance = null;
 
-	public static JSpellChecker getInstance() throws FileNotFoundException, IOException {
+	public static JSpellChecker getInstance() throws FileNotFoundException,
+			IOException {
 		if (_theInstance == null) {
 			create();
@@ -66,10 +71,24 @@
 	}
 
+	public static void create(Frame frame) throws FileNotFoundException,
+			IOException {
+		if(_theInstance == null)
+			_theInstance = new JSpellChecker();
+		_theInstance.init();
+
+		if (frame != null) {
+			for (Text t : frame.getBodyTextItems(false)) {
+				for (String s : t.getText().split(" ")) {
+					_theInstance.checker.addToDictionary(s);
+				}
+			}
+		}
+	}
+
 	public static void create() throws FileNotFoundException, IOException {
-		_theInstance = new JSpellChecker();
-		_theInstance.init();
-	}
-
-	public static String dictFile = FrameIO.PARENT_FOLDER + "dict/english.0";
+		create(null);
+	}
+
+	public static String dictDirectory = FrameIO.PARENT_FOLDER + "dict/";
 
 	public JSpellChecker() {
@@ -79,10 +98,18 @@
 	public void init() throws FileNotFoundException, IOException {
 		log(this.hashCode() + ": JSpellChecker.init");
+		MessageBay.displayMessage("Loading spell checker...");
 
 		checker = new SpellChecker();
-
-		checker.addDictionary(new SpellDictionaryHashMap(new File(dictFile)));
+		SpellDictionaryHashMap dictionaryHashMap = new SpellDictionaryHashMap();
+
+		for (File dict : new File(dictDirectory).listFiles()) {
+			dictionaryHashMap.addDictionary(dict);
+		}
+
+		checker.addDictionary(dictionaryHashMap);
 
 		initialized = true;
+
+		MessageBay.displayMessage("Spell checker Loaded", Color.green.darker());
 	}
 
@@ -97,4 +124,5 @@
 		checker.addSpellCheckListener(listener);
 		checker.reset();
+		event = null;
 	}
 
@@ -137,6 +165,6 @@
 
 		}
-		
-		if(s.length() == 0){
+
+		if (s.length() == 0) {
 			return "No suggestions";
 		}
@@ -146,5 +174,5 @@
 		// + "|";
 		// }
-		return s.substring(0, s.length()-1);
+		return s.substring(0, s.length() - 1);
 	}
 
Index: /trunk/src/org/expeditee/greenstone/Greenstone3Connection.java
===================================================================
--- /trunk/src/org/expeditee/greenstone/Greenstone3Connection.java	(revision 375)
+++ /trunk/src/org/expeditee/greenstone/Greenstone3Connection.java	(revision 376)
@@ -17,5 +17,5 @@
 import java.util.Set;
 
-//import org.apache.xerces.parsers.DOMParser;
+import org.apache.xerces.parsers.DOMParser;
 import org.w3c.dom.Document;
 import org.w3c.dom.NamedNodeMap;
@@ -53,5 +53,5 @@
 	 * keys. All the results returned in this session.
 	 */
-	private Map allResults;
+	private Map<String, ResultDocument> allResults;
 
 	/**
@@ -156,5 +156,6 @@
 		}
 		this.queryList = Collections.synchronizedList(new ArrayList());
-		this.allResults = Collections.synchronizedMap(new HashMap());
+		this.allResults = Collections
+				.synchronizedMap(new HashMap<String, ResultDocument>());
 		this.allKeywords = Collections.synchronizedMap(new HashMap());
 		this.allAuthors = Collections.synchronizedMap(new HashMap());
@@ -164,5 +165,5 @@
 	}
 
-	public Map getSessionResults() {
+	public Map<String, ResultDocument> getSessionResults() {
 		return this.allResults;
 	};
@@ -270,6 +271,5 @@
 		while (iter.hasNext()) {
 			String docID = (String) iter.next();
-			ResultDocument resultDocument = (ResultDocument) allResults
-					.get(docID);
+			ResultDocument resultDocument = allResults.get(docID);
 			System.out.println("____________" + docID + " ___________");
 			System.out.println(resultDocument.toString());
@@ -286,6 +286,5 @@
 		while (iter.hasNext()) {
 			String docID = (String) iter.next();
-			ResultDocument resultDocument = (ResultDocument) allResults
-					.get(docID);
+			ResultDocument resultDocument = allResults.get(docID);
 			System.out.println(docID + "\t" + resultDocument.getTitle());
 		}
@@ -305,5 +304,5 @@
 	 */
 	public ResultDocument getDocument(String docID) {
-		return (ResultDocument) allResults.get(docID);
+		return allResults.get(docID);
 	}
 
@@ -425,76 +424,63 @@
 		StringReader sr = new StringReader(result);
 		InputSource is = new InputSource(sr);
-		
-		
-		
-		
-		
-		
-		
-		
-		
-		
-		return null;
-		
-//		DOMParser p = new DOMParser();
-//
-//		try {
-//			p.parse(is);
-//		} catch (SAXException se) {
-//			System.err.println(se);
-//		} catch (IOException ioe) {
-//			System.err.println(ioe);
-//		}
-//		Document d = p.getDocument();
-//		NodeList metadataList = d.getElementsByTagName("metadata");
-//		for (int i = 0; i < metadataList.getLength(); i++) {
-//			Node n = metadataList.item(i);
-//			NamedNodeMap nnm = n.getAttributes();
-//			Node att = nnm.getNamedItem("name");
-//			if (att.getNodeValue().compareTo("numDocsMatched") == 0) {
-//				queryOutcome.setHowManyDocsMatched(n.getFirstChild()
-//						.getNodeValue());
-//			} else if (att.getNodeValue().compareTo("numDocsReturned") == 0) {
-//				queryOutcome.setHowManyDocsReturned(n.getFirstChild()
-//						.getNodeValue());
-//			}
-//		}
-//
-//		NodeList documentList = d.getElementsByTagName("documentNode");
-//		for (int i = 0; i < documentList.getLength(); i++) {
-//			Node n = documentList.item(i);
-//			NamedNodeMap nnm = n.getAttributes();
-//			Node nid = nnm.getNamedItem("nodeID");
-//			Node nscore = nnm.getNamedItem("rank");
-//			String docID = nid.getFirstChild().getNodeValue();
-//			queryOutcome.addResult(docID, firstDoc + i, nscore.getFirstChild()
-//					.getNodeValue());
-//		}
-//		query.addQueryOutcome(queryOutcome);
-//		Query q = (Query) query.clone();
-//		queryList.add(q);
-//
-//		for (int i = 0; i < documentList.getLength(); i++) {
-//			Node n = documentList.item(i);
-//			NamedNodeMap nnm = n.getAttributes();
-//			Node nid = nnm.getNamedItem("nodeID");
-//			Node nscore = nnm.getNamedItem("rank");
-//			String docID = nid.getFirstChild().getNodeValue();
-//
-//			QueryContext queryContext = new QueryContext(firstDoc + i, nscore
-//					.getFirstChild().getNodeValue(), q);
-//			if (allResults.containsKey(docID)) {
-//				ResultDocument resultDocument = (ResultDocument) allResults
-//						.get(docID);
-//				resultDocument.incrementFrequencyReturned();
-//				resultDocument.addQueryContext(queryContext);
-//				allResults.put(docID, resultDocument);
-//			} else {
-//				ResultDocument resultDocument = new ResultDocument();
-//				resultDocument.addQueryContext(queryContext);
-//				allResults.put(docID, resultDocument);
-//			}
-//		}
-//		return queryOutcome;
+
+		DOMParser p = new DOMParser();
+		try {
+			p.parse(is);
+		} catch (SAXException se) {
+			System.err.println(se);
+		} catch (IOException ioe) {
+			System.err.println(ioe);
+		}
+		Document d = p.getDocument();
+		NodeList metadataList = d.getElementsByTagName("metadata");
+		for (int i = 0; i < metadataList.getLength(); i++) {
+			Node n = metadataList.item(i);
+			NamedNodeMap nnm = n.getAttributes();
+			Node att = nnm.getNamedItem("name");
+			if (att.getNodeValue().compareTo("numDocsMatched") == 0) {
+				queryOutcome.setHowManyDocsMatched(n.getFirstChild()
+						.getNodeValue());
+			} else if (att.getNodeValue().compareTo("numDocsReturned") == 0) {
+				queryOutcome.setHowManyDocsReturned(n.getFirstChild()
+						.getNodeValue());
+			}
+		}
+
+		NodeList documentList = d.getElementsByTagName("documentNode");
+		for (int i = 0; i < documentList.getLength(); i++) {
+			Node n = documentList.item(i);
+			NamedNodeMap nnm = n.getAttributes();
+			Node nid = nnm.getNamedItem("nodeID");
+			Node nscore = nnm.getNamedItem("rank");
+			String docID = nid.getFirstChild().getNodeValue();
+			queryOutcome.addResult(docID, firstDoc + i, nscore.getFirstChild()
+					.getNodeValue());
+		}
+		query.addQueryOutcome(queryOutcome);
+		Query q = (Query) query.clone();
+		queryList.add(q);
+
+		for (int i = 0; i < documentList.getLength(); i++) {
+			Node n = documentList.item(i);
+			NamedNodeMap nnm = n.getAttributes();
+			Node nid = nnm.getNamedItem("nodeID");
+			Node nscore = nnm.getNamedItem("rank");
+			String docID = nid.getFirstChild().getNodeValue();
+
+			QueryContext queryContext = new QueryContext(firstDoc + i, nscore
+					.getFirstChild().getNodeValue(), q);
+			if (allResults.containsKey(docID)) {
+				ResultDocument resultDocument = allResults.get(docID);
+				resultDocument.incrementFrequencyReturned();
+				resultDocument.addQueryContext(queryContext);
+				allResults.put(docID, resultDocument);
+			} else {
+				ResultDocument resultDocument = new ResultDocument();
+				resultDocument.addQueryContext(queryContext);
+				allResults.put(docID, resultDocument);
+			}
+		}
+		return queryOutcome;
 	}
 
@@ -545,5 +531,5 @@
 	 */
 	public void getDocumentMetadataFromServer(String docID, String metadata) {
-		ResultDocument resultDocument = (ResultDocument) allResults.get(docID);
+		ResultDocument resultDocument = allResults.get(docID);
 		if (resultDocument.metadataExists(metadata)) {
 			return;
@@ -566,14 +552,13 @@
 		StringReader sr = new StringReader(result);
 		InputSource is = new InputSource(sr);
-		//DOMParser p = new DOMParser();
-	/*	try {
-			//p.parse(is);
+		DOMParser p = new DOMParser();
+		try {
+			p.parse(is);
 		} catch (SAXException se) {
 			System.err.println(se);
 		} catch (IOException ioe) {
 			System.err.println(ioe);
-		}*/
-		//Document d = p.getDocument();
-		Document d = null;
+		}
+		Document d = p.getDocument();
 		NodeList metadataList = d.getElementsByTagName("metadata");
 		String metadataval = null;
@@ -609,5 +594,5 @@
 					String s = authors[i] + ", " + authors[i + 1];
 
-					//Handle names with jr. in them
+					// Handle names with jr. in them
 					if (containsExtraName) {
 						if (i + 2 < authors.length
@@ -703,17 +688,17 @@
 		StringReader sr = new StringReader(result);
 		InputSource is = new InputSource(sr);
-//		DOMParser p = new DOMParser();
-//		try {
-//			p.parse(is);
-//		} catch (SAXException se) {
-//			System.err.println(se);
-//		} catch (IOException ioe) {
-//			System.err.println(ioe);
-//		}
+		DOMParser p = new DOMParser();
+		try {
+			p.parse(is);
+		} catch (SAXException se) {
+			System.err.println(se);
+		} catch (IOException ioe) {
+			System.err.println(ioe);
+		}
 
 		String returnName = null;
 
-		//Document d = p.getDocument();
-		Document d = null;
+		Document d = p.getDocument();
+		// Document d = null;
 		NodeList metadataList = d.getElementsByTagName("metadata");
 		for (int i = 0; i < metadataList.getLength(); i++) {
@@ -750,14 +735,14 @@
 		StringReader sr = new StringReader(result);
 		InputSource is = new InputSource(sr);
-//		DOMParser p = new DOMParser();
-//		try {
-//			p.parse(is);
-//		} catch (SAXException se) {
-//			System.err.println(se);
-//		} catch (IOException ioe) {
-//			System.err.println(ioe);
-//		}
-//		Document d = p.getDocument();
-		Document d = null;
+		DOMParser p = new DOMParser();
+		try {
+			p.parse(is);
+		} catch (SAXException se) {
+			System.err.println(se);
+		} catch (IOException ioe) {
+			System.err.println(ioe);
+		}
+		Document d = p.getDocument();
+
 		NodeList childList = d.getElementsByTagName("classifierNode");
 		NodeList documentList = d.getElementsByTagName("documentNode");
Index: /trunk/src/org/expeditee/greenstone/ResultDocument.java
===================================================================
--- /trunk/src/org/expeditee/greenstone/ResultDocument.java	(revision 375)
+++ /trunk/src/org/expeditee/greenstone/ResultDocument.java	(revision 376)
@@ -35,4 +35,6 @@
 
 	private Set<String> retrievedMetadata;
+
+	private double sessionScore;
 
 	public ResultDocument() {
@@ -50,4 +52,5 @@
 		publisher = null;
 		frequencyReturned = 1;
+		sessionScore = 0;
 		queryContexts = new Vector<QueryContext>();
 		retrievedMetadata = new HashSet<String>();
@@ -158,4 +161,11 @@
 		this.retrievedMetadata.add("Publisher");
 	}
+	
+	public double getSessionScore() {
+		return this.sessionScore;
+	}
+	public void setSessionScore(double s) {
+		this.sessionScore  = s;
+	}
 
 	public void incrementFrequencyReturned() {
@@ -165,4 +175,6 @@
 	public void addQueryContext(QueryContext queryContext) {
 		this.queryContexts.addElement(queryContext);
+		if (this.frequencyReturned == 1)
+			this.sessionScore = Double.parseDouble(queryContext.getScore());
 	}
 
@@ -170,8 +182,16 @@
 		return authors;
 	}
+	
+	public Vector<String> getAuthor() {
+		return getAuthors();
+	}
 
 	public Vector<String> getKeywords() {
 		return keywords;
 	}
+	
+	public Vector<String> getKeyword() {
+		return getKeywords();
+	}
 
 	public String getTitle() {
@@ -218,6 +238,6 @@
 		return frequencyReturned;
 	}
-
-	public Vector getQueryContexts() {
+	
+	public Vector<QueryContext> getQueryContexts() {
 		return this.queryContexts;
 	}
Index: /trunk/src/org/expeditee/gui/AttributeUtils.java
===================================================================
--- /trunk/src/org/expeditee/gui/AttributeUtils.java	(revision 375)
+++ /trunk/src/org/expeditee/gui/AttributeUtils.java	(revision 376)
@@ -171,4 +171,5 @@
 
 			_SetMethods.put("p", Item.class.getMethod("setPosition", pPoint));
+			_SetMethods.put("xy", Item.class.getMethod("setPosition", pPoint));
 			_SetMethods.put("pos", Item.class.getMethod("setPosition", pPoint));
 			_SetMethods.put("thickness", Item.class.getMethod("setThickness",
@@ -209,6 +210,6 @@
 					"setGradientColor", pColor));
 
-			_SetMethods.put("ga", Item.class.getMethod("setGradientAngle",
-					pInt));
+			_SetMethods.put("ga", Item.class
+					.getMethod("setGradientAngle", pInt));
 			_SetMethods.put("gradientangle", Item.class.getMethod(
 					"setGradientAngle", pInt));
@@ -272,4 +273,6 @@
 			_SetMethods.put("s", Item.class.getMethod("setSize", pFloat));
 
+			// TODO have a separate map for item and frame methods.
+			// This will remove the need for p0 etc
 			_SetMethods.put("foregroundcolor", Frame.class.getMethod(
 					"setForegroundColor", pColor));
@@ -282,4 +285,6 @@
 			_SetMethods.put("permission", Frame.class.getMethod(
 					"setPermission", pPermission));
+			_SetMethods.put("p0", Frame.class.getMethod("setPermission",
+					pPermission));
 
 		} catch (SecurityException e) {
@@ -321,99 +326,12 @@
 			if (m.getDeclaringClass().isAssignableFrom(toExtract.getClass())) {
 				try {
-					Object o = m.invoke(toExtract, (Object[]) null);
-
-					if (o == null) {
-						// methods that return null are only included if they
-						// are in the AllowNull list
-						if (_AllowNull.contains(m)) {
-							String name = m.getName().substring(GET_LENGTH)
-									.toLowerCase();
-							if (name.equals("color"))
-								o = "default";
-							else if (name.equals("backgroundcolor"))
-								o = "transparent";
-							else if (name.equals("foregroundcolor"))
-								o = "auto";
-							else
-								o = "";
-						} else {
-							continue;
-						}
-					}
-					// skip methods that are in the ignore lists
-					if (_ExtractIgnore.contains(m.getName().substring(
-							GET_LENGTH).toLowerCase())) {
+					String s = getValue(m, toExtract, true);
+
+					if (s == null)
 						continue;
-					}
-
-					if (o instanceof Integer) {
-						Integer i = (Integer) o;
-						if (i == Item.DEFAULT_INTEGER)
-							continue;
-						if (m.getName().endsWith("Justification")
-								&& ((Justification) o).toString() != null)
-							o = ((Justification) o).toString();
-						// -1 indicates default value
-						else
-							o = i;
-					} else if (o instanceof Float) {
-						if (((Float) o) < -0.0001)
-							continue;
-						// Null indicates default
-						o = Math.round((Float) o);
-					} else if (o instanceof Double) {
-						// -1 indicates default value
-						if (((Double) o) < 0.0001)
-							continue;
-					} else if (o instanceof Color) {
-						// converts the color to the Expeditee code
-						o = Conversion.getExpediteeColorCode((Color) o);
-						if (o == null)
-							continue;
-					} else if (o instanceof Point) {
-						Point p = (Point) o;
-						o = Math.round(p.getX()) + " " + Math.round(p.getY());
-					} else if (o instanceof Font) {
-						Font f = (Font) o;
-
-						String s = f.getName() + "-";
-						if (f.isPlain())
-							s += "Plain";
-
-						if (f.isBold())
-							s += "Bold";
-
-						if (f.isItalic())
-							s += "Italic";
-
-						s += "-" + f.getSize();
-						o = s;
-					} else if (o instanceof Text) {
-						o = ((Text) o).getFirstLine();
-					} else if (o instanceof List) {
-						List list = (List) o;
-						for (Object ob : list)
-							attributes
-									.append(m.getName().substring(GET_LENGTH))
-									.append(AttributeValuePair.SEPARATOR_STRING)
-									.append(ob).append('\n');
-						continue;
-					} else if (o instanceof int[]) {
-						StringBuffer sb = new StringBuffer();
-						int[] values = (int[]) o;
-						for (int i = 0; i < values.length; i++) {
-							sb.append(values[i]).append(' ');
-						}
-						sb.deleteCharAt(sb.length() - 1);
-						o = sb.toString();
-					} else if (o instanceof Boolean) {
-						// true is the default for boolean values
-						if (((Boolean) o).booleanValue())
-							continue;
-					}
 					// Append the attributes
 					attributes.append(m.getName().substring(GET_LENGTH))
 							.append(AttributeValuePair.SEPARATOR_STRING)
-							.append(o).append('\n');
+							.append(s).append('\n');
 				} catch (Exception e) {
 					// TODO Auto-generated catch block
@@ -434,4 +352,126 @@
 		Item attribs = current.getStatsTextItem(attributes.toString());
 		return attribs;
+	}
+
+	/**
+	 * Gets a string form of the value for a given item get method.
+	 * @param method
+	 * @param item
+	 * @param ignore true if the attributes in the IGNORE list should be ignored
+	 * @return
+	 */
+	private static String getValue(Method method, Object item, boolean ignore) {
+		assert(method.getName().startsWith("get"));
+		
+		Object o = null;
+		try {
+			o = method.invoke(item, (Object[]) null);
+		} catch (IllegalArgumentException e) {
+			e.printStackTrace();
+			return null;
+		} catch (IllegalAccessException e) {
+			e.printStackTrace();
+			return null;
+		} catch (InvocationTargetException e) {
+			e.printStackTrace();
+			return null;
+		}
+
+		if (o == null) {
+			// methods that return null are only included if they
+			// are in the AllowNull list
+			if (_AllowNull.contains(method)) {
+				String name = method.getName().substring(GET_LENGTH)
+						.toLowerCase();
+				if (name.equals("color"))
+					o = "default";
+				else if (name.equals("backgroundcolor"))
+					o = "transparent";
+				else if (name.equals("foregroundcolor"))
+					o = "auto";
+				else
+					o = "";
+			} else {
+				return null;
+			}
+		}
+		// skip methods that are in the ignore lists
+		if (ignore
+				&& _ExtractIgnore.contains(method.getName().substring(
+						GET_LENGTH).toLowerCase())) {
+			return null;
+		}
+
+		if (o instanceof Integer) {
+			Integer i = (Integer) o;
+			if (i == Item.DEFAULT_INTEGER)
+				return null;
+			if (method.getName().endsWith("Justification")
+					&& ((Justification) o).toString() != null)
+				o = ((Justification) o).toString();
+			// -1 indicates default value
+			else
+				o = i;
+		} else if (o instanceof Float) {
+			if (((Float) o) < -0.0001)
+				return null;
+			// Null indicates default
+			o = Math.round((Float) o);
+		} else if (o instanceof Double) {
+			// -1 indicates default value
+			if (((Double) o) < 0.0001)
+				return null;
+		} else if (o instanceof Color) {
+			// converts the color to the Expeditee code
+			o = Conversion.getExpediteeColorCode((Color) o);
+			if (o == null)
+				return null;
+		} else if (o instanceof Point) {
+			Point p = (Point) o;
+			o = Math.round(p.getX()) + " " + Math.round(p.getY());
+		} else if (o instanceof Font) {
+			Font f = (Font) o;
+
+			String s = f.getName() + "-";
+			if (f.isPlain())
+				s += "Plain";
+
+			if (f.isBold())
+				s += "Bold";
+
+			if (f.isItalic())
+				s += "Italic";
+
+			s += "-" + f.getSize();
+			o = s;
+		} else if (o instanceof Text) {
+			o = ((Text) o).getFirstLine();
+		} else if (o instanceof List) {
+			List list = (List) o;
+			StringBuffer sb = new StringBuffer();
+			for (Object ob : list)
+				// TODO check that this works ok
+				if (sb.length() == 0) {
+					sb.append(ob);
+				} else {
+					sb.append('\n').append(
+							method.getName().substring(GET_LENGTH)).append(
+							AttributeValuePair.SEPARATOR_STRING).append(ob);
+				}
+			return sb.toString();
+		} else if (o instanceof int[]) {
+			StringBuffer sb = new StringBuffer();
+			int[] values = (int[]) o;
+			for (int i = 0; i < values.length; i++) {
+				sb.append(values[i]).append(' ');
+			}
+			sb.deleteCharAt(sb.length() - 1);
+			o = sb.toString();
+		} else if (o instanceof Boolean) {
+			// true is the default for boolean values
+			if (((Boolean) o).booleanValue())
+				return null;
+		}
+		return o.toString();
 	}
 
@@ -653,3 +693,29 @@
 		text.setText(avp.toString());
 	}
+
+	public static String getAttribute(Item item, String attribute) {
+
+		// ensure the lists are populated
+		if (_Ignore == null)
+			initLists();
+
+		// separate attribute and value from string
+		String lowerAttribute = attribute.trim().toLowerCase();
+
+		String methodName = "get"
+				+ Character.toUpperCase(lowerAttribute.charAt(0))
+				+ lowerAttribute.substring(1);
+
+		try {
+			return attribute + ": " + getValue(item.getClass().getMethod(methodName,
+					new Class[] {}), item, false);
+		} catch (SecurityException e) {
+			e.printStackTrace();
+		} catch (NoSuchMethodException e) {
+			MessageBay
+					.errorMessage("Could no extract unknown attribute value: "
+							+ attribute);
+		}
+		return null;
+	}
 }
